<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Integrate Rust into Your Existing C++ Project</title>

		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/black.css">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/zenburn.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div class="reveal">
			<div class="slides">

				<section>
					<h1>C++ && Rust</h1>
					<h3>Integrate Rust into Your Existing C++ Project</h3>
					<p>
						<small>Created by <a href="http://github.com/bkircher">Ben Kircher</a></small>
					</p>
				</section>
				<!--
					lalala
					lots of terminal, less presentation
				-->

				<section>
					<p>This is about that one!</p>
					<img data-src="1.png" alt="C++ -> Rust">
				</section>
				<!--
					you are working on a large C++ code base
					want to try Rust for a small problem
					and call that code from within C++
				-->

				<section>
					<p>Not that one.</p>
					<img data-src="2.png" alt="Rust -> C++">
					<p><small>Covered by The Rust Book in <a href="https://doc.rust-lang.org/book/ffi.html">ch 5.9</a>: FFI</small></p>
				</section>
				<!--
					Rust has excellent FFI
					chapter is about using Snappy compression lib from Rust
				-->


				<section>
					<p>Actually, it boils down to</p>
					<img data-src="3.png" alt="Rust -> C">
				</section>

				<section>
					<p>
						Rust has
						<ul>
							<li>Good FFI support for calling C functions, plus</li>
							<li>Tools for automatically generating FFI bindings</li> <!-- from C headers -->
						</ul>
					</p>
				</section>

				<section>
					<p>There is more!</p>
					<p>Automatically translate C code to Rust: Corrode</p>
					<p><a href="https://github.com/jameysharp/corrode">github.com/jameysharp/corrode</a></p>
				</section>
				<!--
					written in Haskell and Python
					very good documented
					a good week-end read
				-->

				<section>
					<p>This is really about this one!</p>
					<img data-src="1.png" alt="C++ -> Rust">
				</section>

				<!--
					but we should go back to our original goal
				-->

				<!--
					and with that it is literally just
				-->

				<section>
					<img data-src="4.png" alt="Node -> Rust">
				</section>

				<section>
					<img data-src="5.png" alt="Python -> Rust">
				</section>

				<section>
					<p>
						In a Node module, you'd write something like
					</p>
					<pre><code class="hljs">
var ffi = require('ffi');
var lib = ffi.Library(
	path.join(__dirname, 'target/release/libfibonacci.so'),
	{
		fibonacci: ['int', ['int']]
	});
var num = lib.fibonacci(20);
					</code></pre>
				</section>

				<section>
					<p>With Python
					</p>
					<pre><code class="python">
from ctypes import cdll

lib = cdll.LoadLibrary('target/debug/libfibonacci.so')
num = lib.fibonacci(20)
					</code></pre>
				</section>

				<section>
					<p>More Rust FFI examples over at</p>
					<p>
						<a href="https://github.com/alexcrichton/rust-ffi-examples">github.com/alexcrichton/rust-ffi-examples</a>
					</p>
				</section>

				<section>
					<p>But back to this one.</p>
					<img data-src="1.png" alt="C++ -> Rust">
				</section>

				<!--
					carge new fib
					cd fib
					vim Cargo.toml
					vim src/main.rs
					fn main() {
					    println!("Hello, world!");
					}
					cargo run

					vim src/lib.rs
					fn fibonacci(x: i32) -> i32 {
						if x <= 2 {
							1
						}
						else {
							fibonacci(x - 1) + fibonacci(x - 2)
						}
					}

					vim src/main.rs
					extern crate fib;
					use fib::fibonacci;
					fn main() {
						// 1 1 2 3 5 8 13 ...
						for i in 1..13 {
							println!("{}: {}", i, fibonacci(i));
						}
					}

					vim Cargo.toml
					[lib]
					name = "fibonacci"
					crate-type = ["dylib"]

					nm target/debug/libfibonacci.dylib |grep fibonacci

					vim src/lib.rs
					#[no_mangle]
					pub extern fn fibonacci(x: i32) -> i32 { /* ... */ }

					nm target/debug/libfibonacci.dylib |grep fibonacci

					...
				-->
				<section>
					<p>Steps:
						<ul>
							<li>make it callable from external code: <a href="file:///usr/local/Cellar/rust/1.10.0/share/doc/rust/html/reference.html#extern-functions"><code>pub extern fn</code></a></li>
							<li>turm of name mangling: <code>#[no_mangle]</code></li>
						</ul>
				</section>
			</div>
		</div>

		<script src="lib/js/head.min.js"></script>
		<script src="js/reveal.js"></script>

		<script>
			// More info https://github.com/hakimel/reveal.js#configuration
			Reveal.initialize({
				history: true,

				// More info https://github.com/hakimel/reveal.js#dependencies
				dependencies: [
					{ src: 'plugin/markdown/marked.js' },
					{ src: 'plugin/markdown/markdown.js' },
					{ src: 'plugin/notes/notes.js', async: true },
					{ src: 'plugin/highlight/highlight.js', async: true, callback: function() { hljs.initHighlightingOnLoad(); } }
				]
			});
		</script>
	</body>
</html>
